<?php
/*
* GamePHP: Open-source library for game development
* Copyright (C) 2005 Jawad Stouli <jawad.xos@gmail.com>
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/**
 * Objet Restore
 *
 * @package Engine
 * @subpackage Objects
 * @author Jawad <jawad.xos@gmail.com>
 */

/**
 * Objet permettant de restaurer une caractristique
 *
 * @package Engine
 * @subpackage Objects
 * @author Jawad <jawad.xos@gmail.com>
 * @todo Adapter au nouveau gestionnaire d'objets
 */
class Restore extends Object {	
	/**
	 * Fonction appele lorsque cet objet est utilis
	 *
	 * @param $Entity Entit utilisant l'objet
	 *
	 * @return Mixed
	 */
	public function _use(Entity &$Entity) {	
		// On appelle la fonction _use de la classe parente
		// Attention: bien faire attention au moment o on appelle cette fonction (vrifier ce que fait la fonction de la classe parente)
		parent::_use($Entity);
	
		// Effectuer l'action
		foreach($this->oCaracs["caracs"] as $key=>$value) {
			if(empty($value["type"])) break;
		
			switch($value["type"]) {
				case "simple":
					$Entity->$key += $value["value"];
				break;
				case "fixed":
					$Entity->$key = $value["value"];
				break;
				case "var":
					$Entity->$key = $Entity->{$value["value"]};
				break;
			}
		}
		
		$Entity->update();
		
		// On jette l'objet (une seule utilisation possible)
		$this->_drop($Entity);
	}
}
?>
