<?php
/*
* GamePHP: Open-source library for game development
* Copyright (C) 2005 Jawad Stouli <jawad.xos@gmail.com>
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/**
 * Classe modle: ajout dynamique de fonctions
 *
 *
 * @package Engine
 * @subpackage Utils
 * @author Jawad <jawad.xos@gmail.com>
 */
 
/**
 * Classe modle
 *
 * Cette classe fournit  ses classes filles la mthode addFunction qui permet d'ajouter de nouvelles fonctions  une classe  l'excution.
 *
 * @package Engine
 * @subpackage Utils
 * @author Jawad <jawad.xos@gmail.com>
 */
class SpecModel {
	/**
	 * Nouvelles fonctions
	 */
	static $specFunctions;
	
	/**
	 * Ajouter une fonction  la classe
	 *
	 * @param String $funcid Identifiant de la fonction (ce qui est appel)
	 * @param String $funcname Nom rel de la fonction
	 *
	 * @return bool
	 */
	static function addFunction($funcid, $funcname) {
		if(isset($funcname)) {
			self::$specFunctions[$funcid] = $funcname;
			
			return true;
		}
		
		return false;
	}
	
	/**
	 * Surcharge de fonctions
	 *
	 * @param String $func Identifiant de la fonction
	 * @param String $args Arguments
	 *
	 * @return Mixed
	 */
	public function __call($funcid, $args) {
		$args[] =& $this;
		
		$funcname = self::$specFunctions[$funcid];
		
		if(isset($funcname)) {
			return $funcname($args);
		}
	}
}
?>