<?php
/*
* GamePHP: Open-source library for game development
* Copyright (C) 2005 Jawad Stouli <jawad.xos@gmail.com>
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

session_start();
if(!isset($_SESSION["id"])) header("Location: index.php");

/* Notre fichier de configuration */
require "config.php";

/* On inclut le fichier de base du moteur */
require _GAMEPHP_ENGINE_DIR."Engine.php";

$Player =& Engine::getEntity("Player", $_SESSION["id"]);

if(!isset($_REQUEST["op"])) quitpage(); // Pas d'action demande, on retourne au dbut

switch($_REQUEST["op"]) {
	case "attack":
		if(!isset($_REQUEST["cibleid"])) {
			quitpage(); // Manque de paramtres, on retourne au dbut
		}
		
		// On cre l'entit ncessaire
		$Cible = new Player($_REQUEST["cibleid"]); // Cible
		
		$Attack = new Action("Attack"); // On cre l'action (action Attack dveloppe pour le jeu dans actions/Attack.php; fichier inclut automatiquement par le moteur)
 		$result = $Attack->act($Player, array("Cible" => &$Cible)); // On appelle la fonction act qui la dclenche
		
		// On crit le rsultat de l'attaque
 		header("Location: game.php?msg={$result->msg}");
	break;
	
	case "move":
		if(!isset($_REQUEST["x"]) || !isset($_REQUEST["y"])) quitpage();
		
		$Move = new Action("Move"); // On cre l'action
		// Notez que le fichier actions/myMove.php est automatiquement inclut par le moteur, et la fonction myMove sera automatiquement appele galement
		$result = $Move->act($Player, array("x" => $_REQUEST["x"], "y" => $_REQUEST["y"]));
		
		// On crit le rsultat du dplacement
		header("Location: game.php?msg={$result->msg}");
	break;
}

function quitpage() {
	header("Location: game.php");
	exit();
}
?>