<?php
/*
* GamePHP: Open-source library for game development
* Copyright (C) 2005 Jawad Stouli <jawad.xos@gmail.com>
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/**
 * Fichier d'action (Move)
 *
 * Cette action se charge de dplacer une entit.
 *
 * @package Engine
 * @subpackage Actions
 */

/**
 * Dplacer une entit
 *
 * Extension de l'action de base du moteur (Move).
 *
 * @param Entity Entit  dplacer
 * @param Array Paramtres de dplacement - array("x" => nouveau x, "y" => nouveau y) -
 *
 * @example Actions/Move.php
 */
function myMove(Entity &$Entity, $params) {
	Global $Actions, $cout_move;
	
	if($Entity->ap_turn < 2) return Warning("Vous n'avez pas assez de points d'action pour effectuer ce mouvement.", "myMove", __FILE__, __LINE__, array("Entit" => $Entity, "params" => $params));

	$Entity->ap_turn -= 2;
}
?>