<?php
/*
* GamePHP: Open-source library for game development
* Copyright (C) 2005 Jawad Stouli <jawad.xos@gmail.com>
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

$debCompteur = time();

session_start();
if(!is_numeric($_SESSION["id"])) header("Location: index.php");

/* Notre fichier de configuration */
require "config.php";

/* On inclut le fichier de base du moteur */
require _GAMEPHP_ENGINE_DIR."Engine.php";

/* On inclut nos fonctions (dveloppes pour le jeu) dont on a besoin */
require "source/Turn.php";
require "source/DrawZone.php";

// On instancie une carte (celle d'id 1)
$myMap =& Engine::getMap(1);

/* On va crer le joueur et rcuprer quelques informations */
$Player =& Engine::getEntity("Player", $_SESSION["id"]);
$Player->turn(); // Fonction dfinie dans source/Turn.php pour vrifier s'il faut activer un nouveau tour

// On cre la zone de la carte que le joueur peut voir (ici, on prend la position du joueur avec un rayon de 3)
$PlayerZone = $myMap->getZone(array("x1" => $Player->x - 3, "x2" => $Player->x + 3, "y1" => $Player->y + 3, "y2" => $Player->y - 3));

// On dfinit la zone $PlayerZone comme zone par dfaut
$myMap->useDefaultZone($PlayerZone);

// On commence la gnration de la page
echo "<?xml version=\"1.0\"?>";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>GamePHP - TestGame</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<meta name="keywords" content="" />
<meta name="description" content="" />
<style type="text/css">@import url(datas/orig.css);</style>
</head>
<body>
<div id="container">
	<div id="nav-main">
		<b><font size="6" color="#FFFFFF"><center>Welcome <?php echo $Player->name; ?></center></font>
		<br />
		<!-- Affichage des rsultats des actions -->
		<font size="4" color="#FFFFFF"><?php echo stripslashes($_GET["msg"]);?></font>
	</div>
	<div id="content">
		<div id="content-main">
			<!-- Affichage de la carte -->
			<?php 
			// On dessine la carte  l'cran
			DrawZone($PlayerZone);
			?>
		</div>
		
		<div id="content-sub">
			<!-- Informations sur le joueur -->
			<table>
				<tr><td><b>Nom</b></td> <td>:</td> <td><?php echo $Player->name;?></td></tr>
				<tr><td><b>Position</b></td> <td>:</td> <td><?php echo "X".$Player->x."/Y".$Player->y;?></td></tr>
				<tr><td><b>Points de vie</b></td> <td>:</td> <td><?php echo $Player->hp_turn."/".$Player->hp;?></td></tr>
				<tr><td><b>Points d'action</b></td> <td>:</td> <td><?php echo $Player->ap_turn."/".$Player->ap;?></td></tr>
				<tr><td><b>Prochain tour</b></td> <td>:</td> <td><?php echo date("d/m/Y H:i:s", $Player->turntime);?></td></tr>
			</table>
			<hr />
			<?php
			$lpos = array(
				0 => array(1, 1, "Move upright"),
				1 => array(1, 0, "Move right"),
				2 => array(1, -1, "Move bottom right"),
				3 => array(0, 1, "Move up"),
				4 => array(0, -1, "Move bottom"),
				5 => array(-1, 1, "Move upleft"),
				6 => array(-1, 0, "Move left"),
				7 => array(-1, -1, "Move bottom left"),
			); // Liste des positions
			
			foreach($lpos as $pos) {
				$newx = $Player->x + $pos[0];
				$newy = $Player->y + $pos[1];
				
				if($myMap->isWalkable(array("x" => $newx, "y" => $newy))) echo "<a href=\"action.php?op=move&x={$newx}&y={$newy}\">{$pos[2]}</a><br />";
			}
			?>
			<hr />
			<!-- Formulaire d'attaque -->
			<form name="attack" id="attack" action="action.php" method="POST">
				<input type="hidden" name="op" id="op" value="attack" />
				<select name="cibleid" id="cibleid">
				<?php
				// On rcupre la liste des entits entourant le joueur (rayon 1)
				$Entities = $myMap->getEntitiesAround(array("x" => $Player->x, "y" => $Player->y), 1);
				foreach($Entities as $Entity) {
					echo "<option value=\"{$Entity["id"]}\">{$Entity["name"]} ({$Entity["id"]})";
				}
				?>
				</select>
				<input type="submit" name="go" id="go" value="Attack!" />
			</form>
		</div>
	</div>
	
	<div id="nav-supp">
		<!-- Lien pour quitter --><a href="quit.php"><b>Exit</b></a> - <?php
			$compteur = time() - $debCompteur;
			echo "Page generated in ".date("i", $compteur)." minute(s) and ".date("s", $compteur)." second(s) / ".$reqcounter." SQL querie(s) used (all databases)";
		?>
	</div>
</div>
</body>
</html>

