<?php
/*
* GamePHP: Open-source library for game development
* Copyright (C) 2005 Jawad Stouli <jawad.xos@gmail.com>
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

function DrawZone(MapZone $MapZone) {
	Global $tilesDir, $objectsDir, $entitiesDir, $Player, $myMap;
	
	// On rcupre la liste des entits dans la zone, nous aurions
	$Entities = $myMap->getEntitiesAround(array("x" => $Player->x, "y" => $Player->y), 3);
	foreach($Entities as $Entity) {
		$MapZone->setPositionEntity(array("x" => $Entity["x"], "y" => $Entity["y"]), $Entity["id"], $Entity["avatar"]);
	}
	
	// On ajoute le joueur  la liste des entits
	$MapZone->setPositionEntity(array("x" => $Player->x, "y" => $Player->y), $Player->id, $Player->avatar);
		
	// On cre un itrateur
	$MyIterator = new ZoneIterator($MapZone);
	
	// On va boucler sur les positions
	// On va utiliser un tableau pour la mise en forme et l'affichage de la carte
	echo "<table align=\"center\" cellspacing=\"0\" cellpadding=\"0\">\n\r";
	echo "	<tr>\n\r		<td></td>";
	
	// On affiche les coordonnes x
	for($i = $MapZone->x[1]; $i <= $MapZone->x[2]; $i++) {
		echo "<td align=\"center\"><font size=\"1\">$i</font></td>\n\r";
	}
	echo "</tr>";
	while($position = $MyIterator->fetchPosition()) {
		// Quels sont les calques de cette position (joueur compris -toujours sur le calque le plus haut-) ?
		foreach($position["layers"] as $layer) {
			switch($layer["type"]) {
				case "tile":
					$b = " background=\"{$tilesDir}".$layer["id"].".png\"";
				break;
				
				case "object":
					$o = "<img src=\"{$objectsDir}".$layer["id"].".png\" />";
				break;
				
				case "entity":				
					$o = "<img src=\"{$entitiesDir}".$layer["id"].".png\" />";
				break;
			}
		}
		
		if($MyIterator->newLine()) echo "<tr>\n\r  <td><font size=\"1\">{$position["y"]}</font></td>\n\r";
			echo "  <td{$b} align=\"center\" width=\"32\" height=\"32\">{$o}</td>\n\r";
		if($MyIterator->endLine()) echo "</tr>\n\r";
		
		unset($b, $o);
	}
	echo "</table>";
}
?>